Dim xl As Object
Dim row As Integer
Dim part As Object
Sub Main
	Set xl = CreateObject("Excel.Application")
	xl.Workbooks.Add
	xl.Visible = True
	Set cell = xl.ActiveCell
	row = 2
	
	Dim pName() As String
	Dim pPartType() As String
	Dim desc() As String
	Dim mfg()  As String
	Dim pval()  As String
	Dim tol()  As String
	Dim pSum()  As Integer
	
	Dim maxSize As Integer
	maxSize = 0
	For Each comp In ActiveDocument.Components
		maxSize = maxSize + 1
	Next
	On Error GoTo 0

	ReDim pName(maxSize)
	ReDim pPartType(maxSize)
	ReDim desc(maxSize)
	ReDim mfg(maxSize)
	ReDim pval(maxSize)
	ReDim tol(maxSize)
	ReDim pSum(maxSize)

	Dim cnt As Integer
	cnt = 0

	For Each comp In ActiveDocument.Components
		Dim isExist As Boolean
		isExist = True
		For i=0 To cnt 
			If pPartType(i) = comp.PartType  And pval(i) = AttrValue(comp, "VALUE") Then
				pName(i) =     pName(i)+"," + comp.Name                    
				pSum(i)  =     pSum(i) + 1
				isExist = False				
			End If
			
		Next

		If isExist Then
			pName(cnt) =      comp.Name                    
			pPartType(cnt) =  comp.PartType                	
			desc(cnt) =      AttrValue(comp, "Description") 	
			mfg(cnt)  =      AttrValue(comp, "Manufacturer #1")   
			pval(cnt)  =      AttrValue(comp, "VALUE")     
			tol(cnt)  =      AttrValue(comp, "TOLERANCE") 
			pSum(cnt) = 1
			cnt = cnt +1
		End If
		

	Next
	On Error GoTo 0

	For i = 0 To cnt -1
		cell.Item(row, 1) = pName(i)
		cell.Item(row, 2) = pSum(i)
		cell.Item(row, 3) = pPartType(i)
		cell.Item(row, 4) = desc(i)
		cell.Item(row, 5) = mfg(i)
		cell.Item(row, 6) = pval(i)
		cell.Item(row, 7) = tol(i)
	
		row = row + 1	   
	Next
	On Error GoTo 0

	xl.Columns("A:G").NumberFormat = "@"
	xl.Range("A1:G1") = Array("RefDes","Item Count", "Part Type","Description","Manufacturer","Value","Tolerance")
	xl.Range("A1:G1").Font.Bold = True
	xl.Range("A1:G1").AutoFilter
	Rem xl.Range("A1").Subtotal GroupBy:=2, Function:=2, TotalList:=Array(2)
	xl.Columns("A:G").AutoFit
End Sub





Function AttrValue (comp As Object, atrName As String) As String
	If comp.Attributes(atrName) Is Nothing Then
		AttrValue = ""
	Else
		AttrValue = comp.Attributes(atrName).value
	End If
End Function

Public Sub Application_OpenDocument(doc As PowerLogic.Document)

End Sub

Public Sub Application_OverwriteLibraryItemPrompt(ByVal itemName As String, varOverwrite As Variant)

End Sub

Public Sub Application_ProgressChange()

End Sub

Public Sub Application_Quit()

End Sub

Public Sub Application_ServerBusy(ByVal bBusy As Boolean)

End Sub

Public Sub Document_SelectionChange()

End Sub

Public Sub View_Change()

End Sub
